IF (MSVC)
	ADD_CUSTOM_TARGET(targets
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo "=========================================================================="
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo "The following make targets are available:"
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo " (a) Libraries:"
		COMMAND ${CMAKE_COMMAND} -E echo "    BALL            builds the BALL library"
		COMMAND ${CMAKE_COMMAND} -E echo "    VIEW            builds the VIEW library"
		COMMAND ${CMAKE_COMMAND} -E echo "    TOOLS           builds BALLs tools"
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo " (b) Applications:"
		COMMAND ${CMAKE_COMMAND} -E echo "    BALLView        builds the viewer/modeller BALLView"
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo " (c) Documentation:"
		COMMAND ${CMAKE_COMMAND} -E echo "    doc             builds the html documentation"
		COMMAND ${CMAKE_COMMAND} -E echo "    doc_dot        	builds the doxygen DOT documentation"
		COMMAND ${CMAKE_COMMAND} -E echo "    doc_tutorial    builds the BALL pdf tutorial"
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo " (d) Tests:"
		COMMAND ${CMAKE_COMMAND} -E echo "    build_tests     builds the unit tests"
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo "=========================================================================="
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMENT "The most important targets for BALL"
		VERBATIM
	)
ELSE()
	ADD_CUSTOM_TARGET(targets
		COMMAND ${CMAKE_COMMAND} -E echo ""	
		COMMAND ${CMAKE_COMMAND} -E echo "=========================================================================="
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo "The following make targets are available:"
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo " (a) Libraries:"
		COMMAND ${CMAKE_COMMAND} -E echo "    BALL            builds the BALL library"
		COMMAND ${CMAKE_COMMAND} -E echo "    VIEW            builds the VIEW library"
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo " (b) Applications:"
		COMMAND ${CMAKE_COMMAND} -E echo "    BALLView        builds the viewer/modeller BALLView"
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo " (c) Documentation:"
		COMMAND ${CMAKE_COMMAND} -E echo "    doc             builds the html documentation"
		COMMAND ${CMAKE_COMMAND} -E echo "    doc_dot         builds the doxygen DOT documentation"
		COMMAND ${CMAKE_COMMAND} -E echo "    doc_tutorial    builds the BALL pdf tutorial"
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo " (d) Tests:"
		COMMAND ${CMAKE_COMMAND} -E echo "    build_tests     builds the unit tests"
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMAND ${CMAKE_COMMAND} -E echo "=========================================================================="
		COMMAND ${CMAKE_COMMAND} -E echo ""
		COMMENT "The most important targets for BALL"
		VERBATIM
	)
ENDIF()
